﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DelegateReflaction
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            InvokeTest();
        }

        private void InvokeTest()
        {
            string dllFilePath = @"D:\Work\Project\Test\DelegateReflaction\TestLibrary\bin\Debug\TestLibrary.dll";
            Assembly assembly = Assembly.LoadFile(dllFilePath);

            Type formType = assembly.GetType("TestLibrary.ChiForm");

            //Child 델리게이트 타입 가져오기
            Type deleType = assembly.GetTypes().Single(a => a.Name == "CallbackDelegate");


            //현재 클래스의 Callback 메서드 정보 가져오기
            MethodInfo callBackMethodInfo = this.GetType().GetMethod("Callback", BindingFlags.NonPublic | BindingFlags.Instance, null, new Type[] { typeof(string) }, null);

            //Child의 CallbackDelegate Delegate를 이용해서 Deleagte 생성
            Delegate callbackMethod = Delegate.CreateDelegate(deleType, this, callBackMethodInfo);

            //Child 폼 생성
            Form form = Activator.CreateInstance(formType) as Form;

            //Child의 DoWork 메서드 가져오기
            MethodInfo doworkMethodInfo = formType.GetMethod("DoWork");

            //파라미터 생성
            object[] parameters = new object[2];
            parameters[0] = "test~";
            parameters[1] = callbackMethod;

            //Child Dowork 메서드 호출
            doworkMethodInfo.Invoke(form, parameters);

            form.Show();
        }

        void Callback(string msg)
        {
            MessageBox.Show(msg);
        }
    }
}
